
/* SPDX-License-Identifier: GPL-2.0 */
/* THIS FILE WAS AUTOGENERATED BY jevents.py arch=riscv model=all ! */

#include <pmu-events/pmu-events.h>
#include "util/header.h"
#include "util/pmu.h"
#include <string.h>
#include <stddef.h>

struct compact_pmu_event {
        int offset;
};

struct pmu_table_entry {
        const struct compact_pmu_event *entries;
        uint32_t num_entries;
        struct compact_pmu_event pmu_name;
};

static const char *const big_c_string =
/* offset=0 */ "tool\000"
/* offset=5 */ "duration_time\000tool\000Wall clock interval time in nanoseconds\000config=1\000\00000\000\000"
/* offset=78 */ "user_time\000tool\000User (non-kernel) time in nanoseconds\000config=2\000\00000\000\000"
/* offset=145 */ "system_time\000tool\000System/kernel time in nanoseconds\000config=3\000\00000\000\000"
/* offset=210 */ "has_pmem\000tool\0001 if persistent memory installed otherwise 0\000config=4\000\00000\000\000"
/* offset=283 */ "num_cores\000tool\000Number of cores. A core consists of 1 or more thread, with each thread being associated with a logical Linux CPU\000config=5\000\00000\000\000"
/* offset=425 */ "num_cpus\000tool\000Number of logical Linux CPUs. There may be multiple such CPUs on a core\000config=6\000\00000\000\000"
/* offset=525 */ "num_cpus_online\000tool\000Number of online logical Linux CPUs. There may be multiple such CPUs on a core\000config=7\000\00000\000\000"
/* offset=639 */ "num_dies\000tool\000Number of dies. Each die has 1 or more cores\000config=8\000\00000\000\000"
/* offset=712 */ "num_packages\000tool\000Number of packages. Each package has 1 or more die\000config=9\000\00000\000\000"
/* offset=795 */ "slots\000tool\000Number of functional units that in parallel can execute parts of an instruction\000config=0xa\000\00000\000\000"
/* offset=902 */ "smt_on\000tool\0001 if simultaneous multithreading (aka hyperthreading) is enable otherwise 0\000config=0xb\000\00000\000\000"
/* offset=1006 */ "system_tsc_freq\000tool\000The amount a Time Stamp Counter (TSC) increases per second\000config=0xc\000\00000\000\000"
/* offset=1102 */ "default_core\000"
/* offset=1115 */ "fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000"
/* offset=1221 */ "fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000"
/* offset=1330 */ "fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000"
/* offset=1424 */ "fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000"
/* offset=1521 */ "fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000"
/* offset=1632 */ "fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000"
/* offset=1716 */ "fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000"
/* offset=1825 */ "fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000"
/* offset=1950 */ "fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000"
/* offset=2087 */ "fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000"
/* offset=2240 */ "fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000"
/* offset=2386 */ "fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000"
/* offset=2548 */ "fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000"
/* offset=2719 */ "fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000"
/* offset=2906 */ "fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000"
/* offset=3055 */ "fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000"
/* offset=3220 */ "fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000"
/* offset=3394 */ "fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000"
/* offset=3584 */ "fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000"
/* offset=3733 */ "fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000"
/* offset=3898 */ "fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000"
/* offset=4072 */ "fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000"
/* offset=4262 */ "cycle_count\000instructions\000Cycle count\000event=0x10\000\00000\000\000"
/* offset=4315 */ "inst_count\000instructions\000Retired instruction count\000event=0x20\000\00000\000\000"
/* offset=4381 */ "int_load_inst\000instructions\000Integer load instruction count\000event=0x30\000\00000\000\000"
/* offset=4455 */ "int_store_inst\000instructions\000Integer store instruction count\000event=0x40\000\00000\000\000"
/* offset=4531 */ "atomic_inst\000instructions\000Atomic instruction count\000event=0x50\000\00000\000\000"
/* offset=4597 */ "sys_inst\000instructions\000System instruction count\000event=0x60\000\00000\000\000"
/* offset=4660 */ "int_compute_inst\000instructions\000Integer computational instruction count\000event=0x70\000\00000\000\000"
/* offset=4746 */ "condition_br\000instructions\000Conditional branch instruction count\000event=0x80\000\00000\000\000"
/* offset=4825 */ "taken_condition_br\000instructions\000Taken conditional branch instruction count\000event=0x90\000\00000\000\000"
/* offset=4916 */ "jal_inst\000instructions\000JAL instruction count\000event=0xa0\000\00000\000\000"
/* offset=4976 */ "jalr_inst\000instructions\000JALR instruction count\000event=0xb0\000\00000\000\000"
/* offset=5038 */ "ret_inst\000instructions\000Return instruction count\000event=0xc0\000\00000\000\000"
/* offset=5101 */ "control_trans_inst\000instructions\000Control transfer instruction count\000event=0xd0\000\00000\000\000"
/* offset=5184 */ "ex9_inst\000instructions\000EXEC.IT instruction count\000event=0xe0\000\00000\000\000"
/* offset=5248 */ "int_mul_inst\000instructions\000Integer multiplication instruction count\000event=0xf0\000\00000\000\000"
/* offset=5331 */ "int_div_rem_inst\000instructions\000Integer division/remainder instruction count\000event=0x100\000\00000\000\000"
/* offset=5423 */ "float_load_inst\000instructions\000Floating-point load instruction count\000event=0x110\000\00000\000\000"
/* offset=5507 */ "float_store_inst\000instructions\000Floating-point store instruction count\000event=0x120\000\00000\000\000"
/* offset=5593 */ "float_add_sub_inst\000instructions\000Floating-point addition/subtraction instruction count\000event=0x130\000\00000\000\000"
/* offset=5696 */ "float_mul_inst\000instructions\000Floating-point multiplication instruction count\000event=0x140\000\00000\000\000"
/* offset=5789 */ "float_fused_muladd_inst\000instructions\000Floating-point fused multiply-add instruction count\000event=0x150\000\00000\000\000"
/* offset=5895 */ "float_div_sqrt_inst\000instructions\000Floating-point division or square-root instruction count\000event=0x160\000\00000\000\000"
/* offset=6002 */ "other_float_inst\000instructions\000Other floating-point instruction count\000event=0x170\000\00000\000\000"
/* offset=6088 */ "int_mul_add_sub_inst\000instructions\000Integer multiplication and add/sub instruction count\000event=0x180\000\00000\000\000"
/* offset=6192 */ "retired_ops\000instructions\000Retired operation count\000event=0x190\000\00000\000\000"
/* offset=6258 */ "ilm_access\000memory\000ILM access\000event=1\000\00000\000\000"
/* offset=6300 */ "dlm_access\000memory\000DLM access\000event=0x11\000\00000\000\000"
/* offset=6345 */ "icache_access\000memory\000ICACHE access\000event=0x21\000\00000\000\000"
/* offset=6396 */ "icache_miss\000memory\000ICACHE miss\000event=0x31\000\00000\000\000"
/* offset=6443 */ "dcache_access\000memory\000DCACHE access\000event=0x41\000\00000\000\000"
/* offset=6494 */ "dcache_miss\000memory\000DCACHE miss\000event=0x51\000\00000\000\000"
/* offset=6541 */ "dcache_load_access\000memory\000DCACHE load access\000event=0x61\000\00000\000\000"
/* offset=6602 */ "dcache_load_miss\000memory\000DCACHE load miss\000event=0x71\000\00000\000\000"
/* offset=6659 */ "dcache_store_access\000memory\000DCACHE store access\000event=0x81\000\00000\000\000"
/* offset=6722 */ "dcache_store_miss\000memory\000DCACHE store miss\000event=0x91\000\00000\000\000"
/* offset=6781 */ "dcache_wb\000memory\000DCACHE writeback\000event=0xa1\000\00000\000\000"
/* offset=6831 */ "cycle_wait_icache_fill\000microarch\000Cycles waiting for ICACHE fill data\000event=0xb1\000\00000\000\000"
/* offset=6916 */ "cycle_wait_dcache_fill\000microarch\000Cycles waiting for DCACHE fill data\000event=0xc1\000\00000\000\000"
/* offset=7001 */ "uncached_ifetch_from_bus\000microarch\000Uncached ifetch data access from bus\000event=0xd1\000\00000\000\000"
/* offset=7089 */ "uncached_load_from_bus\000microarch\000Uncached load data access from bus\000event=0xe1\000\00000\000\000"
/* offset=7173 */ "cycle_wait_uncached_ifetch\000microarch\000Cycles waiting for uncached ifetch data from bus\000event=0xf1\000\00000\000\000"
/* offset=7275 */ "cycle_wait_uncached_load\000microarch\000Cycles waiting for uncached load data from bus\000event=0x101\000\00000\000\000"
/* offset=7374 */ "main_itlb_access\000microarch\000Main ITLB access\000event=0x111\000\00000\000\000"
/* offset=7435 */ "main_itlb_miss\000microarch\000Main ITLB miss\000event=0x121\000\00000\000\000"
/* offset=7492 */ "main_dtlb_access\000microarch\000Main DTLB access\000event=0x131\000\00000\000\000"
/* offset=7553 */ "main_dtlb_miss\000microarch\000Main DTLB miss\000event=0x141\000\00000\000\000"
/* offset=7610 */ "cycle_wait_itlb_fill\000microarch\000Cycles waiting for Main ITLB fill data\000event=0x151\000\00000\000\000"
/* offset=7697 */ "pipe_stall_cycle_dtlb_miss\000microarch\000Pipeline stall cycles caused by Main DTLB miss\000event=0x161\000\00000\000\000"
/* offset=7798 */ "mispredict_condition_br\000microarch\000Misprediction of conditional branches\000event=2\000\00000\000\000"
/* offset=7883 */ "mispredict_take_condition_br\000microarch\000Misprediction of taken conditional branches\000event=0x12\000\00000\000\000"
/* offset=7982 */ "mispredict_target_ret_inst\000microarch\000Misprediction of targets of Return instructions\000event=0x22\000\00000\000\000"
/* offset=8083 */ "exception_taken\000instructions\000Exception taken\000event=0x100\000\00000\000\000"
/* offset=8145 */ "integer_load_retired\000instructions\000Integer load instruction retired\000event=0x200\000\00000\000\000"
/* offset=8229 */ "integer_store_retired\000instructions\000Integer store instruction retired\000event=0x400\000\00000\000\000"
/* offset=8315 */ "atomic_memory_retired\000instructions\000Atomic memory operation retired\000event=0x800\000\00000\000\000"
/* offset=8399 */ "system_instruction_retired\000instructions\000System instruction retired\000event=0x1000\000\00000\000\000"
/* offset=8484 */ "integer_arithmetic_retired\000instructions\000Integer arithmetic instruction retired\000event=0x2000\000\00000\000\000"
/* offset=8581 */ "conditional_branch_retired\000instructions\000Conditional branch retired\000event=0x4000\000\00000\000\000"
/* offset=8666 */ "jal_instruction_retired\000instructions\000JAL instruction retired\000event=0x8000\000\00000\000\000"
/* offset=8745 */ "jalr_instruction_retired\000instructions\000JALR instruction retired\000event=0x10000\000\00000\000\000"
/* offset=8827 */ "integer_multiplication_retired\000instructions\000Integer multiplication instruction retired\000event=0x20000\000\00000\000\000"
/* offset=8933 */ "integer_division_retired\000instructions\000Integer division instruction retired\000event=0x40000\000\00000\000\000"
/* offset=9027 */ "fp_load_retired\000instructions\000Floating-point load instruction retired\000event=0x80000\000\00000\000\000"
/* offset=9115 */ "fp_store_retired\000instructions\000Floating-point store instruction retired\000event=0x100000\000\00000\000\000"
/* offset=9206 */ "fp_addition_retired\000instructions\000Floating-point addition retired\000event=0x200000\000\00000\000\000"
/* offset=9291 */ "fp_multiplication_retired\000instructions\000Floating-point multiplication retired\000event=0x400000\000\00000\000\000"
/* offset=9388 */ "fp_fusedmadd_retired\000instructions\000Floating-point fused multiply-add retired\000event=0x800000\000\00000\000\000"
/* offset=9484 */ "fp_div_sqrt_retired\000instructions\000Floating-point division or square-root retired\000event=0x1000000\000\00000\000\000"
/* offset=9585 */ "other_fp_retired\000instructions\000Other floating-point instruction retired\000event=0x2000000\000\00000\000\000"
/* offset=9677 */ "icache_retired\000memory\000Instruction cache miss\000event=0x102\000\00000\000\000"
/* offset=9739 */ "dcache_miss_mmio_accesses\000memory\000Data cache miss or memory-mapped I/O access\000event=0x202\000\00000\000\000"
/* offset=9833 */ "dcache_writeback\000memory\000Data cache write-back\000event=0x402\000\00000\000\000"
/* offset=9896 */ "inst_tlb_miss\000memory\000Instruction TLB miss\000event=0x802\000\00000\000\000"
/* offset=9955 */ "data_tlb_miss\000memory\000Data TLB miss\000event=0x1002\000\00000\000\000"
/* offset=10008 */ "utlb_miss\000memory\000UTLB miss\000event=0x2002\000\00000\000\000"
/* offset=10053 */ "addressgen_interlock\000microarch\000Address-generation interlock\000event=0x101\000\00000\000\000"
/* offset=10130 */ "longlat_interlock\000microarch\000Long-latency interlock\000event=0x201\000\00000\000\000"
/* offset=10198 */ "csr_read_interlock\000microarch\000CSR read interlock\000event=0x401\000\00000\000\000"
/* offset=10263 */ "icache_itim_busy\000microarch\000Instruction cache/ITIM busy\000event=0x801\000\00000\000\000"
/* offset=10335 */ "dcache_dtim_busy\000microarch\000Data cache/DTIM busy\000event=0x1001\000\00000\000\000"
/* offset=10401 */ "branch_direction_misprediction\000microarch\000Branch direction misprediction\000event=0x2001\000\00000\000\000"
/* offset=10491 */ "branch_target_misprediction\000microarch\000Branch/jump target misprediction\000event=0x4001\000\00000\000\000"
/* offset=10580 */ "pipe_flush_csr_write\000microarch\000Pipeline flush from CSR write\000event=0x8001\000\00000\000\000"
/* offset=10659 */ "pipe_flush_other_event\000microarch\000Pipeline flush from other event\000event=0x10001\000\00000\000\000"
/* offset=10743 */ "integer_multiplication_interlock\000microarch\000Integer multiplication interlock\000event=0x20001\000\00000\000\000"
/* offset=10838 */ "fp_interlock\000microarch\000Floating-point interlock\000event=0x40001\000\00000\000\000"
/* offset=10905 */ "access_mmu_stlb\000common\000access MMU STLB\000event=1\000\00000\000\000"
/* offset=10957 */ "miss_mmu_stlb\000common\000miss MMU STLB\000event=2\000\00000\000\000"
/* offset=11005 */ "access_mmu_pte_c\000common\000access MMU PTE-Cache\000event=3\000\00000\000\000"
/* offset=11063 */ "miss_mmu_pte_c\000common\000miss MMU PTE-Cache\000event=4\000\00000\000\000"
/* offset=11117 */ "rob_flush\000common\000ROB flush (all kinds of exceptions)\000event=5\000\00000\000\000"
/* offset=11183 */ "btb_prediction_miss\000common\000BTB prediction miss\000event=6\000\00000\000\000"
/* offset=11243 */ "itlb_miss\000common\000ITLB miss\000event=7\000\00000\000\000"
/* offset=11283 */ "sync_del_fetch_g\000common\000SYNC delivery a fetch-group\000event=8\000\00000\000\000"
/* offset=11348 */ "icache_miss\000common\000ICache miss\000event=9\000\00000\000\000"
/* offset=11392 */ "bpu_br_retire\000common\000condition branch instruction retire\000event=0xa\000\00000\000\000"
/* offset=11464 */ "bpu_br_miss\000common\000condition branch instruction miss\000event=0xb\000\00000\000\000"
/* offset=11532 */ "ret_ins_retire\000common\000return instruction retire\000event=0xc\000\00000\000\000"
/* offset=11595 */ "ret_ins_miss\000common\000return instruction miss\000event=0xd\000\00000\000\000"
/* offset=11654 */ "indirect_jr_miss\000common\000indirect JR instruction miss (inlcude without target)\000event=0xe\000\00000\000\000"
/* offset=11747 */ "ibuf_val_id_nordy\000common\000IBUF valid while ID not ready\000event=0xf\000\00000\000\000"
/* offset=11817 */ "ibuf_noval_id_rdy\000common\000IBUF not valid while ID ready\000event=0x10\000\00000\000\000"
/* offset=11888 */ "ren_int_phy_reg_nordy\000common\000REN integer physical register file is not ready\000event=0x11\000\00000\000\000"
/* offset=11981 */ "ren_fp_phy_reg_nordy\000common\000REN floating point physical register file is not ready\000event=0x12\000\00000\000\000"
/* offset=12080 */ "ren_cp_nordy\000common\000REN checkpoint is not ready\000event=0x13\000\00000\000\000"
/* offset=12144 */ "dec_val_rob_nordy\000common\000DEC is valid and ROB is not ready\000event=0x14\000\00000\000\000"
/* offset=12219 */ "ood_flush_ls_dep\000common\000out of order flush due to load/store dependency\000event=0x15\000\00000\000\000"
/* offset=12307 */ "bru_ret_ijr_ins\000common\000BRU retire an IJR instruction\000event=0x16\000\00000\000\000"
/* offset=12376 */ "access_dtlb\000common\000access DTLB\000event=0x17\000\00000\000\000"
/* offset=12423 */ "miss_dtlb\000common\000miss DTLB\000event=0x18\000\00000\000\000"
/* offset=12466 */ "load_ins_dcache\000common\000load instruction access DCache\000event=0x19\000\00000\000\000"
/* offset=12536 */ "load_ins_miss_dcache\000common\000load instruction miss DCache\000event=0x1a\000\00000\000\000"
/* offset=12609 */ "store_ins_dcache\000common\000store/amo instruction access DCache\000event=0x1b\000\00000\000\000"
/* offset=12685 */ "store_ins_miss_dcache\000common\000store/amo instruction miss DCache\000event=0x1c\000\00000\000\000"
/* offset=12764 */ "load_scache\000common\000load access SCache\000event=0x1d\000\00000\000\000"
/* offset=12818 */ "store_scache\000common\000store access SCache\000event=0x1e\000\00000\000\000"
/* offset=12874 */ "load_miss_scache\000common\000load miss SCache\000event=0x1f\000\00000\000\000"
/* offset=12931 */ "store_miss_scache\000common\000store miss SCache\000event=0x20\000\00000\000\000"
/* offset=12990 */ "l2c_pf_req\000common\000L2C data-prefetcher request\000event=0x21\000\00000\000\000"
/* offset=13052 */ "l2c_pf_hit\000common\000L2C data-prefetcher hit\000event=0x22\000\00000\000\000"
/* offset=13110 */ "l1_icache_access\000cache\000L1 instruction cache access\000event=1\000\00000\000\000"
/* offset=13174 */ "l1_icache_miss\000cache\000L1 instruction cache miss\000event=2\000\00000\000\000"
/* offset=13234 */ "itlb_miss\000cache\000I-UTLB miss\000event=3\000\00000\000\000"
/* offset=13275 */ "dtlb_miss\000cache\000D-UTLB miss\000event=4\000\00000\000\000"
/* offset=13316 */ "jtlb_miss\000cache\000JTLB miss\000event=5\000\00000\000\000"
/* offset=13355 */ "l1_dcache_read_access\000cache\000L1 data cache read access\000event=0xc\000\00000\000\000"
/* offset=13424 */ "l1_dcache_read_miss\000cache\000L1 data cache read miss\000event=0xd\000\00000\000\000"
/* offset=13489 */ "l1_dcache_write_access\000cache\000L1 data cache write access\000event=0xe\000\00000\000\000"
/* offset=13560 */ "l1_dcache_write_miss\000cache\000L1 data cache write miss\000event=0xf\000\00000\000\000"
/* offset=13627 */ "ll_cache_read_access\000cache\000LL Cache read access\000event=0x10\000\00000\000\000"
/* offset=13691 */ "ll_cache_read_miss\000cache\000LL Cache read miss\000event=0x11\000\00000\000\000"
/* offset=13751 */ "ll_cache_write_access\000cache\000LL Cache write access\000event=0x12\000\00000\000\000"
/* offset=13817 */ "ll_cache_write_miss\000cache\000LL Cache write miss\000event=0x13\000\00000\000\000"
/* offset=13879 */ "inst_branch_mispredict\000instruction\000Mispredicted branch instructions\000event=6\000\00000\000\000"
/* offset=13960 */ "inst_branch\000instruction\000Retired branch instructions\000event=7\000\00000\000\000"
/* offset=14025 */ "inst_jmp_mispredict\000instruction\000Indirect branch mispredict\000event=8\000\00000\000\000"
/* offset=14097 */ "inst_jmp\000instruction\000Retired jmp instructions\000event=9\000\00000\000\000"
/* offset=14156 */ "inst_store\000instruction\000Retired store instructions\000event=0xb\000\00000\000\000"
/* offset=14221 */ "inst_alu\000instruction\000Retired ALU instructions\000event=0x1d\000\00000\000\000"
/* offset=14283 */ "inst_ldst\000instruction\000Retired Load/Store instructions\000event=0x1e\000\00000\000\000"
/* offset=14353 */ "inst_vector\000instruction\000Retired Vector instructions\000event=0x1f\000\00000\000\000"
/* offset=14421 */ "inst_csr\000instruction\000Retired CSR instructions\000event=0x20\000\00000\000\000"
/* offset=14483 */ "inst_sync\000instruction\000Retired sync instructions (AMO/LR/SC instructions)\000event=0x21\000\00000\000\000"
/* offset=14572 */ "inst_unaligned_access\000instruction\000Retired Store/Load instructions with unaligned memory access\000event=0x22\000\00000\000\000"
/* offset=14683 */ "inst_ecall\000instruction\000Retired ecall instructions\000event=0x25\000\00000\000\000"
/* offset=14749 */ "inst_long_jp\000instruction\000Retired long jump instructions\000event=0x26\000\00000\000\000"
/* offset=14821 */ "inst_fp\000instruction\000Retired FPU instructions\000event=0x2a\000\00000\000\000"
/* offset=14882 */ "lsu_spec_fail\000microarch\000LSU speculation fail\000event=0xa\000\00000\000\000"
/* offset=14942 */ "idu_rf_pipe_fail\000microarch\000Instruction decode unit launch pipeline failed in RF state\000event=0x14\000\00000\000\000"
/* offset=15044 */ "idu_rf_reg_fail\000microarch\000Instruction decode unit launch register file fail in RF state\000event=0x15\000\00000\000\000"
/* offset=15148 */ "idu_rf_instruction\000microarch\000retired instruction count of Instruction decode unit in RF (Register File) stage\000event=0x16\000\00000\000\000"
/* offset=15274 */ "lsu_4k_stall\000microarch\000LSU stall times for long distance data access (Over 4K)\000event=0x17\000\00000\000This stall occurs when translate virtual address with page offset over 4k\000"
/* offset=15442 */ "lsu_other_stall\000microarch\000LSU stall times for other reasons (except the 4k stall)\000event=0x18\000\00000\000\000"
/* offset=15540 */ "lsu_sq_other_dis\000microarch\000LSU store queue discard others\000event=0x19\000\00000\000\000"
/* offset=15614 */ "lsu_sq_data_discard\000microarch\000LSU store queue discard data (uops)\000event=0x1a\000\00000\000\000"
/* offset=15696 */ "branch_direction_misprediction\000microarch\000Branch misprediction in BTB\000event=0x1b\000\00000\000\000"
/* offset=15781 */ "branch_direction_prediction\000microarch\000All branch prediction in BTB\000event=0x1c\000\00000\000This event including both successful prediction and failed prediction in BTB\000"
/* offset=15940 */ "interrupt_ack_count\000microarch\000acknowledged interrupt count\000event=0x23\000\00000\000\000"
/* offset=16015 */ "interrupt_off_cycle\000microarch\000PLIC arbitration time when the interrupt is not responded\000event=0x24\000\00000\000The arbitration time is recorded while meeting any of the following:\n- CPU is M-mode and MIE == 0\n- CPU is S-mode and delegation and SIE == 0\n\000"
/* offset=16261 */ "ifu_stalled_cycle\000microarch\000Number of stall cycles of the instruction fetch unit (IFU)\000event=0x27\000\00000\000\000"
/* offset=16364 */ "idu_stalled_cycle\000microarch\000hpcp_backend_stall Number of stall cycles of the instruction decoding unit (IDU) and next-level pipeline unit\000event=0x28\000\00000\000\000"
/* offset=16518 */ "sync_stall\000microarch\000Sync instruction stall cycle fence/fence.i/sync/sfence\000event=0x29\000\00000\000\000"
/* offset=16610 */ "bp_l1_btb_correct\000branch\000L1 BTB Correction\000event=0x8a\000\00000\000\000"
/* offset=16669 */ "bp_l2_btb_correct\000branch\000L2 BTB Correction\000event=0x8b\000\00000\000\000"
/* offset=16728 */ "l3_cache_rd\000cache\000L3 cache access, read\000event=0x40\000\00000\000Attributable Level 3 cache access, read\000"
/* offset=16823 */ "segment_reg_loads.any\000other\000Number of segment register loads\000event=6,period=200000,umask=0x80\000\00000\000\000"
/* offset=16922 */ "dispatch_blocked.any\000other\000Memory cluster signals to block micro-op dispatch for any reason\000event=9,period=200000,umask=0x20\000\00000\000\000"
/* offset=17052 */ "eist_trans\000other\000Number of Enhanced Intel SpeedStep(R) Technology (EIST) transitions\000event=0x3a,period=200000\000\00000\000\000"
/* offset=17167 */ "hisi_sccl,ddrc\000"
/* offset=17182 */ "uncore_hisi_ddrc.flux_wcmd\000uncore\000DDRC write commands\000event=2\000\00000\000DDRC write commands\000"
/* offset=17268 */ "uncore_cbox\000"
/* offset=17280 */ "unc_cbo_xsnp_response.miss_eviction\000uncore\000A cross-core snoop resulted from L3 Eviction which misses in some processor core\000event=0x22,umask=0x81\000\00000\000A cross-core snoop resulted from L3 Eviction which misses in some processor core\000"
/* offset=17511 */ "event-hyphen\000uncore\000UNC_CBO_HYPHEN\000event=0xe0\000\00000\000UNC_CBO_HYPHEN\000"
/* offset=17576 */ "event-two-hyph\000uncore\000UNC_CBO_TWO_HYPH\000event=0xc0\000\00000\000UNC_CBO_TWO_HYPH\000"
/* offset=17647 */ "hisi_sccl,l3c\000"
/* offset=17661 */ "uncore_hisi_l3c.rd_hit_cpipe\000uncore\000Total read hits\000event=7\000\00000\000Total read hits\000"
/* offset=17741 */ "uncore_imc_free_running\000"
/* offset=17765 */ "uncore_imc_free_running.cache_miss\000uncore\000Total cache misses\000event=0x12\000\00000\000Total cache misses\000"
/* offset=17860 */ "uncore_imc\000"
/* offset=17871 */ "uncore_imc.cache_hits\000uncore\000Total cache hits\000event=0x34\000\00000\000Total cache hits\000"
/* offset=17949 */ "uncore_sys_ddr_pmu\000"
/* offset=17968 */ "sys_ddr_pmu.write_cycles\000uncore\000ddr write-cycles event\000event=0x2b\000v8\00000\000\000"
/* offset=18041 */ "uncore_sys_ccn_pmu\000"
/* offset=18060 */ "sys_ccn_pmu.read_cycles\000uncore\000ccn read-cycles event\000config=0x2c\0000x01\00000\000\000"
/* offset=18134 */ "uncore_sys_cmn_pmu\000"
/* offset=18153 */ "sys_cmn_pmu.hnf_cache_miss\000uncore\000Counts total cache misses in first lookup result (high priority)\000eventid=1,type=5\000(434|436|43c|43a).*\00000\000\000"
/* offset=18293 */ "CPI\000\0001 / IPC\000\000\000\000\000\000\000\00000"
/* offset=18315 */ "IPC\000group1\000inst_retired.any / cpu_clk_unhalted.thread\000\000\000\000\000\000\000\00000"
/* offset=18378 */ "Frontend_Bound_SMT\000\000idq_uops_not_delivered.core / (4 * (cpu_clk_unhalted.thread / 2 * (1 + cpu_clk_unhalted.one_thread_active / cpu_clk_unhalted.ref_xclk)))\000\000\000\000\000\000\000\00000"
/* offset=18544 */ "dcache_miss_cpi\000\000l1d\\-loads\\-misses / inst_retired.any\000\000\000\000\000\000\000\00000"
/* offset=18608 */ "icache_miss_cycles\000\000l1i\\-loads\\-misses / inst_retired.any\000\000\000\000\000\000\000\00000"
/* offset=18675 */ "cache_miss_cycles\000group1\000dcache_miss_cpi + icache_miss_cycles\000\000\000\000\000\000\000\00000"
/* offset=18746 */ "DCache_L2_All_Hits\000\000l2_rqsts.demand_data_rd_hit + l2_rqsts.pf_hit + l2_rqsts.rfo_hit\000\000\000\000\000\000\000\00000"
/* offset=18840 */ "DCache_L2_All_Miss\000\000max(l2_rqsts.all_demand_data_rd - l2_rqsts.demand_data_rd_hit, 0) + l2_rqsts.pf_miss + l2_rqsts.rfo_miss\000\000\000\000\000\000\000\00000"
/* offset=18974 */ "DCache_L2_All\000\000DCache_L2_All_Hits + DCache_L2_All_Miss\000\000\000\000\000\000\000\00000"
/* offset=19038 */ "DCache_L2_Hits\000\000d_ratio(DCache_L2_All_Hits, DCache_L2_All)\000\000\000\000\000\000\000\00000"
/* offset=19106 */ "DCache_L2_Misses\000\000d_ratio(DCache_L2_All_Miss, DCache_L2_All)\000\000\000\000\000\000\000\00000"
/* offset=19176 */ "M1\000\000ipc + M2\000\000\000\000\000\000\000\00000"
/* offset=19198 */ "M2\000\000ipc + M1\000\000\000\000\000\000\000\00000"
/* offset=19220 */ "M3\000\0001 / M3\000\000\000\000\000\000\000\00000"
/* offset=19240 */ "L1D_Cache_Fill_BW\000\00064 * l1d.replacement / 1e9 / duration_time\000\000\000\000\000\000\000\00000"
;

static const struct compact_pmu_event pmu_events__common_tool[] = {
{ 5 }, /* duration_time\000tool\000Wall clock interval time in nanoseconds\000config=1\000\00000\000\000 */
{ 210 }, /* has_pmem\000tool\0001 if persistent memory installed otherwise 0\000config=4\000\00000\000\000 */
{ 283 }, /* num_cores\000tool\000Number of cores. A core consists of 1 or more thread, with each thread being associated with a logical Linux CPU\000config=5\000\00000\000\000 */
{ 425 }, /* num_cpus\000tool\000Number of logical Linux CPUs. There may be multiple such CPUs on a core\000config=6\000\00000\000\000 */
{ 525 }, /* num_cpus_online\000tool\000Number of online logical Linux CPUs. There may be multiple such CPUs on a core\000config=7\000\00000\000\000 */
{ 639 }, /* num_dies\000tool\000Number of dies. Each die has 1 or more cores\000config=8\000\00000\000\000 */
{ 712 }, /* num_packages\000tool\000Number of packages. Each package has 1 or more die\000config=9\000\00000\000\000 */
{ 795 }, /* slots\000tool\000Number of functional units that in parallel can execute parts of an instruction\000config=0xa\000\00000\000\000 */
{ 902 }, /* smt_on\000tool\0001 if simultaneous multithreading (aka hyperthreading) is enable otherwise 0\000config=0xb\000\00000\000\000 */
{ 145 }, /* system_time\000tool\000System/kernel time in nanoseconds\000config=3\000\00000\000\000 */
{ 1006 }, /* system_tsc_freq\000tool\000The amount a Time Stamp Counter (TSC) increases per second\000config=0xc\000\00000\000\000 */
{ 78 }, /* user_time\000tool\000User (non-kernel) time in nanoseconds\000config=2\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__common[] = {
{
     .entries = pmu_events__common_tool,
     .num_entries = ARRAY_SIZE(pmu_events__common_tool),
     .pmu_name = { 0 /* tool\000 */ },
},
};

static const struct compact_pmu_event pmu_events__andes_ax45_default_core[] = {
{ 4531 }, /* atomic_inst\000instructions\000Atomic instruction count\000event=0x50\000\00000\000\000 */
{ 4746 }, /* condition_br\000instructions\000Conditional branch instruction count\000event=0x80\000\00000\000\000 */
{ 5101 }, /* control_trans_inst\000instructions\000Control transfer instruction count\000event=0xd0\000\00000\000\000 */
{ 4262 }, /* cycle_count\000instructions\000Cycle count\000event=0x10\000\00000\000\000 */
{ 6916 }, /* cycle_wait_dcache_fill\000microarch\000Cycles waiting for DCACHE fill data\000event=0xc1\000\00000\000\000 */
{ 6831 }, /* cycle_wait_icache_fill\000microarch\000Cycles waiting for ICACHE fill data\000event=0xb1\000\00000\000\000 */
{ 7610 }, /* cycle_wait_itlb_fill\000microarch\000Cycles waiting for Main ITLB fill data\000event=0x151\000\00000\000\000 */
{ 7173 }, /* cycle_wait_uncached_ifetch\000microarch\000Cycles waiting for uncached ifetch data from bus\000event=0xf1\000\00000\000\000 */
{ 7275 }, /* cycle_wait_uncached_load\000microarch\000Cycles waiting for uncached load data from bus\000event=0x101\000\00000\000\000 */
{ 6443 }, /* dcache_access\000memory\000DCACHE access\000event=0x41\000\00000\000\000 */
{ 6541 }, /* dcache_load_access\000memory\000DCACHE load access\000event=0x61\000\00000\000\000 */
{ 6602 }, /* dcache_load_miss\000memory\000DCACHE load miss\000event=0x71\000\00000\000\000 */
{ 6494 }, /* dcache_miss\000memory\000DCACHE miss\000event=0x51\000\00000\000\000 */
{ 6659 }, /* dcache_store_access\000memory\000DCACHE store access\000event=0x81\000\00000\000\000 */
{ 6722 }, /* dcache_store_miss\000memory\000DCACHE store miss\000event=0x91\000\00000\000\000 */
{ 6781 }, /* dcache_wb\000memory\000DCACHE writeback\000event=0xa1\000\00000\000\000 */
{ 6300 }, /* dlm_access\000memory\000DLM access\000event=0x11\000\00000\000\000 */
{ 5184 }, /* ex9_inst\000instructions\000EXEC.IT instruction count\000event=0xe0\000\00000\000\000 */
{ 5593 }, /* float_add_sub_inst\000instructions\000Floating-point addition/subtraction instruction count\000event=0x130\000\00000\000\000 */
{ 5895 }, /* float_div_sqrt_inst\000instructions\000Floating-point division or square-root instruction count\000event=0x160\000\00000\000\000 */
{ 5789 }, /* float_fused_muladd_inst\000instructions\000Floating-point fused multiply-add instruction count\000event=0x150\000\00000\000\000 */
{ 5423 }, /* float_load_inst\000instructions\000Floating-point load instruction count\000event=0x110\000\00000\000\000 */
{ 5696 }, /* float_mul_inst\000instructions\000Floating-point multiplication instruction count\000event=0x140\000\00000\000\000 */
{ 5507 }, /* float_store_inst\000instructions\000Floating-point store instruction count\000event=0x120\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 6345 }, /* icache_access\000memory\000ICACHE access\000event=0x21\000\00000\000\000 */
{ 6396 }, /* icache_miss\000memory\000ICACHE miss\000event=0x31\000\00000\000\000 */
{ 6258 }, /* ilm_access\000memory\000ILM access\000event=1\000\00000\000\000 */
{ 4315 }, /* inst_count\000instructions\000Retired instruction count\000event=0x20\000\00000\000\000 */
{ 4660 }, /* int_compute_inst\000instructions\000Integer computational instruction count\000event=0x70\000\00000\000\000 */
{ 5331 }, /* int_div_rem_inst\000instructions\000Integer division/remainder instruction count\000event=0x100\000\00000\000\000 */
{ 4381 }, /* int_load_inst\000instructions\000Integer load instruction count\000event=0x30\000\00000\000\000 */
{ 6088 }, /* int_mul_add_sub_inst\000instructions\000Integer multiplication and add/sub instruction count\000event=0x180\000\00000\000\000 */
{ 5248 }, /* int_mul_inst\000instructions\000Integer multiplication instruction count\000event=0xf0\000\00000\000\000 */
{ 4455 }, /* int_store_inst\000instructions\000Integer store instruction count\000event=0x40\000\00000\000\000 */
{ 4916 }, /* jal_inst\000instructions\000JAL instruction count\000event=0xa0\000\00000\000\000 */
{ 4976 }, /* jalr_inst\000instructions\000JALR instruction count\000event=0xb0\000\00000\000\000 */
{ 7492 }, /* main_dtlb_access\000microarch\000Main DTLB access\000event=0x131\000\00000\000\000 */
{ 7553 }, /* main_dtlb_miss\000microarch\000Main DTLB miss\000event=0x141\000\00000\000\000 */
{ 7374 }, /* main_itlb_access\000microarch\000Main ITLB access\000event=0x111\000\00000\000\000 */
{ 7435 }, /* main_itlb_miss\000microarch\000Main ITLB miss\000event=0x121\000\00000\000\000 */
{ 7798 }, /* mispredict_condition_br\000microarch\000Misprediction of conditional branches\000event=2\000\00000\000\000 */
{ 7883 }, /* mispredict_take_condition_br\000microarch\000Misprediction of taken conditional branches\000event=0x12\000\00000\000\000 */
{ 7982 }, /* mispredict_target_ret_inst\000microarch\000Misprediction of targets of Return instructions\000event=0x22\000\00000\000\000 */
{ 6002 }, /* other_float_inst\000instructions\000Other floating-point instruction count\000event=0x170\000\00000\000\000 */
{ 7697 }, /* pipe_stall_cycle_dtlb_miss\000microarch\000Pipeline stall cycles caused by Main DTLB miss\000event=0x161\000\00000\000\000 */
{ 5038 }, /* ret_inst\000instructions\000Return instruction count\000event=0xc0\000\00000\000\000 */
{ 6192 }, /* retired_ops\000instructions\000Retired operation count\000event=0x190\000\00000\000\000 */
{ 4597 }, /* sys_inst\000instructions\000System instruction count\000event=0x60\000\00000\000\000 */
{ 4825 }, /* taken_condition_br\000instructions\000Taken conditional branch instruction count\000event=0x90\000\00000\000\000 */
{ 7001 }, /* uncached_ifetch_from_bus\000microarch\000Uncached ifetch data access from bus\000event=0xd1\000\00000\000\000 */
{ 7089 }, /* uncached_load_from_bus\000microarch\000Uncached load data access from bus\000event=0xe1\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__andes_ax45[] = {
{
     .entries = pmu_events__andes_ax45_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__andes_ax45_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__sifive_u74_default_core[] = {
{ 10053 }, /* addressgen_interlock\000microarch\000Address-generation interlock\000event=0x101\000\00000\000\000 */
{ 8315 }, /* atomic_memory_retired\000instructions\000Atomic memory operation retired\000event=0x800\000\00000\000\000 */
{ 10401 }, /* branch_direction_misprediction\000microarch\000Branch direction misprediction\000event=0x2001\000\00000\000\000 */
{ 10491 }, /* branch_target_misprediction\000microarch\000Branch/jump target misprediction\000event=0x4001\000\00000\000\000 */
{ 8581 }, /* conditional_branch_retired\000instructions\000Conditional branch retired\000event=0x4000\000\00000\000\000 */
{ 10198 }, /* csr_read_interlock\000microarch\000CSR read interlock\000event=0x401\000\00000\000\000 */
{ 9955 }, /* data_tlb_miss\000memory\000Data TLB miss\000event=0x1002\000\00000\000\000 */
{ 10335 }, /* dcache_dtim_busy\000microarch\000Data cache/DTIM busy\000event=0x1001\000\00000\000\000 */
{ 9739 }, /* dcache_miss_mmio_accesses\000memory\000Data cache miss or memory-mapped I/O access\000event=0x202\000\00000\000\000 */
{ 9833 }, /* dcache_writeback\000memory\000Data cache write-back\000event=0x402\000\00000\000\000 */
{ 8083 }, /* exception_taken\000instructions\000Exception taken\000event=0x100\000\00000\000\000 */
{ 9206 }, /* fp_addition_retired\000instructions\000Floating-point addition retired\000event=0x200000\000\00000\000\000 */
{ 9484 }, /* fp_div_sqrt_retired\000instructions\000Floating-point division or square-root retired\000event=0x1000000\000\00000\000\000 */
{ 9388 }, /* fp_fusedmadd_retired\000instructions\000Floating-point fused multiply-add retired\000event=0x800000\000\00000\000\000 */
{ 10838 }, /* fp_interlock\000microarch\000Floating-point interlock\000event=0x40001\000\00000\000\000 */
{ 9027 }, /* fp_load_retired\000instructions\000Floating-point load instruction retired\000event=0x80000\000\00000\000\000 */
{ 9291 }, /* fp_multiplication_retired\000instructions\000Floating-point multiplication retired\000event=0x400000\000\00000\000\000 */
{ 9115 }, /* fp_store_retired\000instructions\000Floating-point store instruction retired\000event=0x100000\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 10263 }, /* icache_itim_busy\000microarch\000Instruction cache/ITIM busy\000event=0x801\000\00000\000\000 */
{ 9677 }, /* icache_retired\000memory\000Instruction cache miss\000event=0x102\000\00000\000\000 */
{ 9896 }, /* inst_tlb_miss\000memory\000Instruction TLB miss\000event=0x802\000\00000\000\000 */
{ 8484 }, /* integer_arithmetic_retired\000instructions\000Integer arithmetic instruction retired\000event=0x2000\000\00000\000\000 */
{ 8933 }, /* integer_division_retired\000instructions\000Integer division instruction retired\000event=0x40000\000\00000\000\000 */
{ 8145 }, /* integer_load_retired\000instructions\000Integer load instruction retired\000event=0x200\000\00000\000\000 */
{ 10743 }, /* integer_multiplication_interlock\000microarch\000Integer multiplication interlock\000event=0x20001\000\00000\000\000 */
{ 8827 }, /* integer_multiplication_retired\000instructions\000Integer multiplication instruction retired\000event=0x20000\000\00000\000\000 */
{ 8229 }, /* integer_store_retired\000instructions\000Integer store instruction retired\000event=0x400\000\00000\000\000 */
{ 8666 }, /* jal_instruction_retired\000instructions\000JAL instruction retired\000event=0x8000\000\00000\000\000 */
{ 8745 }, /* jalr_instruction_retired\000instructions\000JALR instruction retired\000event=0x10000\000\00000\000\000 */
{ 10130 }, /* longlat_interlock\000microarch\000Long-latency interlock\000event=0x201\000\00000\000\000 */
{ 9585 }, /* other_fp_retired\000instructions\000Other floating-point instruction retired\000event=0x2000000\000\00000\000\000 */
{ 10580 }, /* pipe_flush_csr_write\000microarch\000Pipeline flush from CSR write\000event=0x8001\000\00000\000\000 */
{ 10659 }, /* pipe_flush_other_event\000microarch\000Pipeline flush from other event\000event=0x10001\000\00000\000\000 */
{ 8399 }, /* system_instruction_retired\000instructions\000System instruction retired\000event=0x1000\000\00000\000\000 */
{ 10008 }, /* utlb_miss\000memory\000UTLB miss\000event=0x2002\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__sifive_u74[] = {
{
     .entries = pmu_events__sifive_u74_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__sifive_u74_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__starfive_dubhe_80_default_core[] = {
{ 12376 }, /* access_dtlb\000common\000access DTLB\000event=0x17\000\00000\000\000 */
{ 11005 }, /* access_mmu_pte_c\000common\000access MMU PTE-Cache\000event=3\000\00000\000\000 */
{ 10905 }, /* access_mmu_stlb\000common\000access MMU STLB\000event=1\000\00000\000\000 */
{ 11464 }, /* bpu_br_miss\000common\000condition branch instruction miss\000event=0xb\000\00000\000\000 */
{ 11392 }, /* bpu_br_retire\000common\000condition branch instruction retire\000event=0xa\000\00000\000\000 */
{ 12307 }, /* bru_ret_ijr_ins\000common\000BRU retire an IJR instruction\000event=0x16\000\00000\000\000 */
{ 11183 }, /* btb_prediction_miss\000common\000BTB prediction miss\000event=6\000\00000\000\000 */
{ 12144 }, /* dec_val_rob_nordy\000common\000DEC is valid and ROB is not ready\000event=0x14\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 11817 }, /* ibuf_noval_id_rdy\000common\000IBUF not valid while ID ready\000event=0x10\000\00000\000\000 */
{ 11747 }, /* ibuf_val_id_nordy\000common\000IBUF valid while ID not ready\000event=0xf\000\00000\000\000 */
{ 11348 }, /* icache_miss\000common\000ICache miss\000event=9\000\00000\000\000 */
{ 11654 }, /* indirect_jr_miss\000common\000indirect JR instruction miss (inlcude without target)\000event=0xe\000\00000\000\000 */
{ 11243 }, /* itlb_miss\000common\000ITLB miss\000event=7\000\00000\000\000 */
{ 13052 }, /* l2c_pf_hit\000common\000L2C data-prefetcher hit\000event=0x22\000\00000\000\000 */
{ 12990 }, /* l2c_pf_req\000common\000L2C data-prefetcher request\000event=0x21\000\00000\000\000 */
{ 12466 }, /* load_ins_dcache\000common\000load instruction access DCache\000event=0x19\000\00000\000\000 */
{ 12536 }, /* load_ins_miss_dcache\000common\000load instruction miss DCache\000event=0x1a\000\00000\000\000 */
{ 12874 }, /* load_miss_scache\000common\000load miss SCache\000event=0x1f\000\00000\000\000 */
{ 12764 }, /* load_scache\000common\000load access SCache\000event=0x1d\000\00000\000\000 */
{ 12423 }, /* miss_dtlb\000common\000miss DTLB\000event=0x18\000\00000\000\000 */
{ 11063 }, /* miss_mmu_pte_c\000common\000miss MMU PTE-Cache\000event=4\000\00000\000\000 */
{ 10957 }, /* miss_mmu_stlb\000common\000miss MMU STLB\000event=2\000\00000\000\000 */
{ 12219 }, /* ood_flush_ls_dep\000common\000out of order flush due to load/store dependency\000event=0x15\000\00000\000\000 */
{ 12080 }, /* ren_cp_nordy\000common\000REN checkpoint is not ready\000event=0x13\000\00000\000\000 */
{ 11981 }, /* ren_fp_phy_reg_nordy\000common\000REN floating point physical register file is not ready\000event=0x12\000\00000\000\000 */
{ 11888 }, /* ren_int_phy_reg_nordy\000common\000REN integer physical register file is not ready\000event=0x11\000\00000\000\000 */
{ 11595 }, /* ret_ins_miss\000common\000return instruction miss\000event=0xd\000\00000\000\000 */
{ 11532 }, /* ret_ins_retire\000common\000return instruction retire\000event=0xc\000\00000\000\000 */
{ 11117 }, /* rob_flush\000common\000ROB flush (all kinds of exceptions)\000event=5\000\00000\000\000 */
{ 12609 }, /* store_ins_dcache\000common\000store/amo instruction access DCache\000event=0x1b\000\00000\000\000 */
{ 12685 }, /* store_ins_miss_dcache\000common\000store/amo instruction miss DCache\000event=0x1c\000\00000\000\000 */
{ 12931 }, /* store_miss_scache\000common\000store miss SCache\000event=0x20\000\00000\000\000 */
{ 12818 }, /* store_scache\000common\000store access SCache\000event=0x1e\000\00000\000\000 */
{ 11283 }, /* sync_del_fetch_g\000common\000SYNC delivery a fetch-group\000event=8\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__starfive_dubhe_80[] = {
{
     .entries = pmu_events__starfive_dubhe_80_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__starfive_dubhe_80_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__thead_c900_legacy_default_core[] = {
{ 15696 }, /* branch_direction_misprediction\000microarch\000Branch misprediction in BTB\000event=0x1b\000\00000\000\000 */
{ 15781 }, /* branch_direction_prediction\000microarch\000All branch prediction in BTB\000event=0x1c\000\00000\000This event including both successful prediction and failed prediction in BTB\000 */
{ 13275 }, /* dtlb_miss\000cache\000D-UTLB miss\000event=4\000\00000\000\000 */
{ 1330 }, /* fw_access_load\000firmware\000Load access trap event\000config=0x8000000000000002\000\00000\000Load access trap\000 */
{ 1424 }, /* fw_access_store\000firmware\000Store access trap event\000config=0x8000000000000003\000\00000\000Store access trap\000 */
{ 2087 }, /* fw_fence_i_received\000firmware\000Received FENCE.I request from other HART event\000config=0x8000000000000009\000\00000\000Received FENCE.I request from other HART event\000 */
{ 1950 }, /* fw_fence_i_sent\000firmware\000Sent FENCE.I request to other HART event\000config=0x8000000000000008\000\00000\000Sent FENCE.I request to other HART event\000 */
{ 3055 }, /* fw_hfence_gvma_received\000firmware\000Received HFENCE.GVMA request from other HART event\000config=0x800000000000000f\000\00000\000Received HFENCE.GVMA request from other HART event\000 */
{ 2906 }, /* fw_hfence_gvma_sent\000firmware\000Sent HFENCE.GVMA request to other HART event\000config=0x800000000000000e\000\00000\000Sent HFENCE.GVMA request to other HART event\000 */
{ 3394 }, /* fw_hfence_gvma_vmid_received\000firmware\000Received HFENCE.GVMA with VMID request from other HART event\000config=0x8000000000000011\000\00000\000Received HFENCE.GVMA with VMID request from other HART event\000 */
{ 3220 }, /* fw_hfence_gvma_vmid_sent\000firmware\000Sent HFENCE.GVMA with VMID request to other HART event\000config=0x8000000000000010\000\00000\000Sent HFENCE.GVMA with VMID request to other HART event\000 */
{ 4072 }, /* fw_hfence_vvma_asid_received\000firmware\000Received HFENCE.VVMA with ASID request from other HART event\000config=0x8000000000000015\000\00000\000Received HFENCE.VVMA with ASID request from other HART event\000 */
{ 3898 }, /* fw_hfence_vvma_asid_sent\000firmware\000Sent HFENCE.VVMA with ASID request to other HART event\000config=0x8000000000000014\000\00000\000Sent HFENCE.VVMA with ASID request to other HART event\000 */
{ 3733 }, /* fw_hfence_vvma_received\000firmware\000Received HFENCE.VVMA request from other HART event\000config=0x8000000000000013\000\00000\000Received HFENCE.VVMA request from other HART event\000 */
{ 3584 }, /* fw_hfence_vvma_sent\000firmware\000Sent HFENCE.VVMA request to other HART event\000config=0x8000000000000012\000\00000\000Sent HFENCE.VVMA request to other HART event\000 */
{ 1521 }, /* fw_illegal_insn\000firmware\000Illegal instruction trap event\000config=0x8000000000000004\000\00000\000Illegal instruction trap\000 */
{ 1825 }, /* fw_ipi_received\000firmware\000Received IPI from other HART event\000config=0x8000000000000007\000\00000\000Received IPI from other HART event\000 */
{ 1716 }, /* fw_ipi_sent\000firmware\000Sent IPI to other HART event\000config=0x8000000000000006\000\00000\000Sent IPI to other HART event\000 */
{ 1115 }, /* fw_misaligned_load\000firmware\000Misaligned load trap event\000config=0x8000000000000000\000\00000\000Misaligned load trap\000 */
{ 1221 }, /* fw_misaligned_store\000firmware\000Misaligned store trap event\000config=0x8000000000000001\000\00000\000Misaligned store trap\000 */
{ 1632 }, /* fw_set_timer\000firmware\000Set timer event\000config=0x8000000000000005\000\00000\000Set timer event\000 */
{ 2719 }, /* fw_sfence_vma_asid_received\000firmware\000Received SFENCE.VMA with ASID request from other HART event\000config=0x800000000000000d\000\00000\000Received SFENCE.VMA with ASID request from other HART event\000 */
{ 2548 }, /* fw_sfence_vma_asid_sent\000firmware\000Sent SFENCE.VMA with ASID request to other HART event\000config=0x800000000000000c\000\00000\000Sent SFENCE.VMA with ASID request to other HART event\000 */
{ 2386 }, /* fw_sfence_vma_received\000firmware\000Received SFENCE.VMA request from other HART event\000config=0x800000000000000b\000\00000\000Received SFENCE.VMA request from other HART event\000 */
{ 2240 }, /* fw_sfence_vma_sent\000firmware\000Sent SFENCE.VMA request to other HART event\000config=0x800000000000000a\000\00000\000Sent SFENCE.VMA request to other HART event\000 */
{ 15148 }, /* idu_rf_instruction\000microarch\000retired instruction count of Instruction decode unit in RF (Register File) stage\000event=0x16\000\00000\000\000 */
{ 14942 }, /* idu_rf_pipe_fail\000microarch\000Instruction decode unit launch pipeline failed in RF state\000event=0x14\000\00000\000\000 */
{ 15044 }, /* idu_rf_reg_fail\000microarch\000Instruction decode unit launch register file fail in RF state\000event=0x15\000\00000\000\000 */
{ 16364 }, /* idu_stalled_cycle\000microarch\000hpcp_backend_stall Number of stall cycles of the instruction decoding unit (IDU) and next-level pipeline unit\000event=0x28\000\00000\000\000 */
{ 16261 }, /* ifu_stalled_cycle\000microarch\000Number of stall cycles of the instruction fetch unit (IFU)\000event=0x27\000\00000\000\000 */
{ 14221 }, /* inst_alu\000instruction\000Retired ALU instructions\000event=0x1d\000\00000\000\000 */
{ 13960 }, /* inst_branch\000instruction\000Retired branch instructions\000event=7\000\00000\000\000 */
{ 13879 }, /* inst_branch_mispredict\000instruction\000Mispredicted branch instructions\000event=6\000\00000\000\000 */
{ 14421 }, /* inst_csr\000instruction\000Retired CSR instructions\000event=0x20\000\00000\000\000 */
{ 14683 }, /* inst_ecall\000instruction\000Retired ecall instructions\000event=0x25\000\00000\000\000 */
{ 14821 }, /* inst_fp\000instruction\000Retired FPU instructions\000event=0x2a\000\00000\000\000 */
{ 14097 }, /* inst_jmp\000instruction\000Retired jmp instructions\000event=9\000\00000\000\000 */
{ 14025 }, /* inst_jmp_mispredict\000instruction\000Indirect branch mispredict\000event=8\000\00000\000\000 */
{ 14283 }, /* inst_ldst\000instruction\000Retired Load/Store instructions\000event=0x1e\000\00000\000\000 */
{ 14749 }, /* inst_long_jp\000instruction\000Retired long jump instructions\000event=0x26\000\00000\000\000 */
{ 14156 }, /* inst_store\000instruction\000Retired store instructions\000event=0xb\000\00000\000\000 */
{ 14483 }, /* inst_sync\000instruction\000Retired sync instructions (AMO/LR/SC instructions)\000event=0x21\000\00000\000\000 */
{ 14572 }, /* inst_unaligned_access\000instruction\000Retired Store/Load instructions with unaligned memory access\000event=0x22\000\00000\000\000 */
{ 14353 }, /* inst_vector\000instruction\000Retired Vector instructions\000event=0x1f\000\00000\000\000 */
{ 15940 }, /* interrupt_ack_count\000microarch\000acknowledged interrupt count\000event=0x23\000\00000\000\000 */
{ 16015 }, /* interrupt_off_cycle\000microarch\000PLIC arbitration time when the interrupt is not responded\000event=0x24\000\00000\000The arbitration time is recorded while meeting any of the following:\n- CPU is M-mode and MIE == 0\n- CPU is S-mode and delegation and SIE == 0\n\000 */
{ 13234 }, /* itlb_miss\000cache\000I-UTLB miss\000event=3\000\00000\000\000 */
{ 13316 }, /* jtlb_miss\000cache\000JTLB miss\000event=5\000\00000\000\000 */
{ 13355 }, /* l1_dcache_read_access\000cache\000L1 data cache read access\000event=0xc\000\00000\000\000 */
{ 13424 }, /* l1_dcache_read_miss\000cache\000L1 data cache read miss\000event=0xd\000\00000\000\000 */
{ 13489 }, /* l1_dcache_write_access\000cache\000L1 data cache write access\000event=0xe\000\00000\000\000 */
{ 13560 }, /* l1_dcache_write_miss\000cache\000L1 data cache write miss\000event=0xf\000\00000\000\000 */
{ 13110 }, /* l1_icache_access\000cache\000L1 instruction cache access\000event=1\000\00000\000\000 */
{ 13174 }, /* l1_icache_miss\000cache\000L1 instruction cache miss\000event=2\000\00000\000\000 */
{ 13627 }, /* ll_cache_read_access\000cache\000LL Cache read access\000event=0x10\000\00000\000\000 */
{ 13691 }, /* ll_cache_read_miss\000cache\000LL Cache read miss\000event=0x11\000\00000\000\000 */
{ 13751 }, /* ll_cache_write_access\000cache\000LL Cache write access\000event=0x12\000\00000\000\000 */
{ 13817 }, /* ll_cache_write_miss\000cache\000LL Cache write miss\000event=0x13\000\00000\000\000 */
{ 15274 }, /* lsu_4k_stall\000microarch\000LSU stall times for long distance data access (Over 4K)\000event=0x17\000\00000\000This stall occurs when translate virtual address with page offset over 4k\000 */
{ 15442 }, /* lsu_other_stall\000microarch\000LSU stall times for other reasons (except the 4k stall)\000event=0x18\000\00000\000\000 */
{ 14882 }, /* lsu_spec_fail\000microarch\000LSU speculation fail\000event=0xa\000\00000\000\000 */
{ 15614 }, /* lsu_sq_data_discard\000microarch\000LSU store queue discard data (uops)\000event=0x1a\000\00000\000\000 */
{ 15540 }, /* lsu_sq_other_dis\000microarch\000LSU store queue discard others\000event=0x19\000\00000\000\000 */
{ 16518 }, /* sync_stall\000microarch\000Sync instruction stall cycle fence/fence.i/sync/sfence\000event=0x29\000\00000\000\000 */

};

const struct pmu_table_entry pmu_events__thead_c900_legacy[] = {
{
     .entries = pmu_events__thead_c900_legacy_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__thead_c900_legacy_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__test_soc_cpu_default_core[] = {
{ 16610 }, /* bp_l1_btb_correct\000branch\000L1 BTB Correction\000event=0x8a\000\00000\000\000 */
{ 16669 }, /* bp_l2_btb_correct\000branch\000L2 BTB Correction\000event=0x8b\000\00000\000\000 */
{ 16922 }, /* dispatch_blocked.any\000other\000Memory cluster signals to block micro-op dispatch for any reason\000event=9,period=200000,umask=0x20\000\00000\000\000 */
{ 17052 }, /* eist_trans\000other\000Number of Enhanced Intel SpeedStep(R) Technology (EIST) transitions\000event=0x3a,period=200000\000\00000\000\000 */
{ 16728 }, /* l3_cache_rd\000cache\000L3 cache access, read\000event=0x40\000\00000\000Attributable Level 3 cache access, read\000 */
{ 16823 }, /* segment_reg_loads.any\000other\000Number of segment register loads\000event=6,period=200000,umask=0x80\000\00000\000\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_hisi_sccl_ddrc[] = {
{ 17182 }, /* uncore_hisi_ddrc.flux_wcmd\000uncore\000DDRC write commands\000event=2\000\00000\000DDRC write commands\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_hisi_sccl_l3c[] = {
{ 17661 }, /* uncore_hisi_l3c.rd_hit_cpipe\000uncore\000Total read hits\000event=7\000\00000\000Total read hits\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_uncore_cbox[] = {
{ 17511 }, /* event-hyphen\000uncore\000UNC_CBO_HYPHEN\000event=0xe0\000\00000\000UNC_CBO_HYPHEN\000 */
{ 17576 }, /* event-two-hyph\000uncore\000UNC_CBO_TWO_HYPH\000event=0xc0\000\00000\000UNC_CBO_TWO_HYPH\000 */
{ 17280 }, /* unc_cbo_xsnp_response.miss_eviction\000uncore\000A cross-core snoop resulted from L3 Eviction which misses in some processor core\000event=0x22,umask=0x81\000\00000\000A cross-core snoop resulted from L3 Eviction which misses in some processor core\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_uncore_imc[] = {
{ 17871 }, /* uncore_imc.cache_hits\000uncore\000Total cache hits\000event=0x34\000\00000\000Total cache hits\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_cpu_uncore_imc_free_running[] = {
{ 17765 }, /* uncore_imc_free_running.cache_miss\000uncore\000Total cache misses\000event=0x12\000\00000\000Total cache misses\000 */

};

const struct pmu_table_entry pmu_events__test_soc_cpu[] = {
{
     .entries = pmu_events__test_soc_cpu_default_core,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_hisi_sccl_ddrc,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_hisi_sccl_ddrc),
     .pmu_name = { 17167 /* hisi_sccl,ddrc\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_hisi_sccl_l3c,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_hisi_sccl_l3c),
     .pmu_name = { 17647 /* hisi_sccl,l3c\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_uncore_cbox,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_uncore_cbox),
     .pmu_name = { 17268 /* uncore_cbox\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_uncore_imc,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_uncore_imc),
     .pmu_name = { 17860 /* uncore_imc\000 */ },
},
{
     .entries = pmu_events__test_soc_cpu_uncore_imc_free_running,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_cpu_uncore_imc_free_running),
     .pmu_name = { 17741 /* uncore_imc_free_running\000 */ },
},
};

static const struct compact_pmu_event pmu_metrics__test_soc_cpu_default_core[] = {
{ 18293 }, /* CPI\000\0001 / IPC\000\000\000\000\000\000\000\00000 */
{ 18974 }, /* DCache_L2_All\000\000DCache_L2_All_Hits + DCache_L2_All_Miss\000\000\000\000\000\000\000\00000 */
{ 18746 }, /* DCache_L2_All_Hits\000\000l2_rqsts.demand_data_rd_hit + l2_rqsts.pf_hit + l2_rqsts.rfo_hit\000\000\000\000\000\000\000\00000 */
{ 18840 }, /* DCache_L2_All_Miss\000\000max(l2_rqsts.all_demand_data_rd - l2_rqsts.demand_data_rd_hit, 0) + l2_rqsts.pf_miss + l2_rqsts.rfo_miss\000\000\000\000\000\000\000\00000 */
{ 19038 }, /* DCache_L2_Hits\000\000d_ratio(DCache_L2_All_Hits, DCache_L2_All)\000\000\000\000\000\000\000\00000 */
{ 19106 }, /* DCache_L2_Misses\000\000d_ratio(DCache_L2_All_Miss, DCache_L2_All)\000\000\000\000\000\000\000\00000 */
{ 18378 }, /* Frontend_Bound_SMT\000\000idq_uops_not_delivered.core / (4 * (cpu_clk_unhalted.thread / 2 * (1 + cpu_clk_unhalted.one_thread_active / cpu_clk_unhalted.ref_xclk)))\000\000\000\000\000\000\000\00000 */
{ 18315 }, /* IPC\000group1\000inst_retired.any / cpu_clk_unhalted.thread\000\000\000\000\000\000\000\00000 */
{ 19240 }, /* L1D_Cache_Fill_BW\000\00064 * l1d.replacement / 1e9 / duration_time\000\000\000\000\000\000\000\00000 */
{ 19176 }, /* M1\000\000ipc + M2\000\000\000\000\000\000\000\00000 */
{ 19198 }, /* M2\000\000ipc + M1\000\000\000\000\000\000\000\00000 */
{ 19220 }, /* M3\000\0001 / M3\000\000\000\000\000\000\000\00000 */
{ 18675 }, /* cache_miss_cycles\000group1\000dcache_miss_cpi + icache_miss_cycles\000\000\000\000\000\000\000\00000 */
{ 18544 }, /* dcache_miss_cpi\000\000l1d\\-loads\\-misses / inst_retired.any\000\000\000\000\000\000\000\00000 */
{ 18608 }, /* icache_miss_cycles\000\000l1i\\-loads\\-misses / inst_retired.any\000\000\000\000\000\000\000\00000 */

};

const struct pmu_table_entry pmu_metrics__test_soc_cpu[] = {
{
     .entries = pmu_metrics__test_soc_cpu_default_core,
     .num_entries = ARRAY_SIZE(pmu_metrics__test_soc_cpu_default_core),
     .pmu_name = { 1102 /* default_core\000 */ },
},
};

static const struct compact_pmu_event pmu_events__test_soc_sys_uncore_sys_ccn_pmu[] = {
{ 18060 }, /* sys_ccn_pmu.read_cycles\000uncore\000ccn read-cycles event\000config=0x2c\0000x01\00000\000\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_sys_uncore_sys_cmn_pmu[] = {
{ 18153 }, /* sys_cmn_pmu.hnf_cache_miss\000uncore\000Counts total cache misses in first lookup result (high priority)\000eventid=1,type=5\000(434|436|43c|43a).*\00000\000\000 */
};
static const struct compact_pmu_event pmu_events__test_soc_sys_uncore_sys_ddr_pmu[] = {
{ 17968 }, /* sys_ddr_pmu.write_cycles\000uncore\000ddr write-cycles event\000event=0x2b\000v8\00000\000\000 */

};

const struct pmu_table_entry pmu_events__test_soc_sys[] = {
{
     .entries = pmu_events__test_soc_sys_uncore_sys_ccn_pmu,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_sys_uncore_sys_ccn_pmu),
     .pmu_name = { 18041 /* uncore_sys_ccn_pmu\000 */ },
},
{
     .entries = pmu_events__test_soc_sys_uncore_sys_cmn_pmu,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_sys_uncore_sys_cmn_pmu),
     .pmu_name = { 18134 /* uncore_sys_cmn_pmu\000 */ },
},
{
     .entries = pmu_events__test_soc_sys_uncore_sys_ddr_pmu,
     .num_entries = ARRAY_SIZE(pmu_events__test_soc_sys_uncore_sys_ddr_pmu),
     .pmu_name = { 17949 /* uncore_sys_ddr_pmu\000 */ },
},
};


/* Struct used to make the PMU event table implementation opaque to callers. */
struct pmu_events_table {
        const struct pmu_table_entry *pmus;
        uint32_t num_pmus;
};

/* Struct used to make the PMU metric table implementation opaque to callers. */
struct pmu_metrics_table {
        const struct pmu_table_entry *pmus;
        uint32_t num_pmus;
};

/*
 * Map a CPU to its table of PMU events. The CPU is identified by the
 * cpuid field, which is an arch-specific identifier for the CPU.
 * The identifier specified in tools/perf/pmu-events/arch/xxx/mapfile
 * must match the get_cpuid_str() in tools/perf/arch/xxx/util/header.c)
 *
 * The  cpuid can contain any character other than the comma.
 */
struct pmu_events_map {
        const char *arch;
        const char *cpuid;
        struct pmu_events_table event_table;
        struct pmu_metrics_table metric_table;
};

/*
 * Global table mapping each known CPU for the architecture to its
 * table of PMU events.
 */
const struct pmu_events_map pmu_events_map[] = {
{
	.arch = "common",
	.cpuid = "common",
	.event_table = {
		.pmus = pmu_events__common,
		.num_pmus = ARRAY_SIZE(pmu_events__common),
	},
	.metric_table = {},
},
{
	.arch = "riscv",
	.cpuid = "0x489-0x8000000000000007-0x[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__sifive_u74,
		.num_pmus = ARRAY_SIZE(pmu_events__sifive_u74)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x5b7-0x0-0x0",
	.event_table = {
		.pmus = pmu_events__thead_c900_legacy,
		.num_pmus = ARRAY_SIZE(pmu_events__thead_c900_legacy)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x67e-0x80000000db0000[89]0-0x[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__starfive_dubhe_80,
		.num_pmus = ARRAY_SIZE(pmu_events__starfive_dubhe_80)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "riscv",
	.cpuid = "0x31e-0x8000000000008a45-0x[[:xdigit:]]+",
	.event_table = {
		.pmus = pmu_events__andes_ax45,
		.num_pmus = ARRAY_SIZE(pmu_events__andes_ax45)
	},
	.metric_table = {
		.pmus = NULL,
		.num_pmus = 0
	}
},
{
	.arch = "testarch",
	.cpuid = "testcpu",
	.event_table = {
		.pmus = pmu_events__test_soc_cpu,
		.num_pmus = ARRAY_SIZE(pmu_events__test_soc_cpu),
	},
	.metric_table = {
		.pmus = pmu_metrics__test_soc_cpu,
		.num_pmus = ARRAY_SIZE(pmu_metrics__test_soc_cpu),
	}
},
{
	.arch = 0,
	.cpuid = 0,
	.event_table = { 0, 0 },
	.metric_table = { 0, 0 },
}
};

struct pmu_sys_events {
	const char *name;
	struct pmu_events_table event_table;
	struct pmu_metrics_table metric_table;
};

static const struct pmu_sys_events pmu_sys_event_tables[] = {
	{
		.event_table = {
			.pmus = pmu_events__test_soc_sys,
			.num_pmus = ARRAY_SIZE(pmu_events__test_soc_sys)
		},
		.name = "pmu_events__test_soc_sys",
	},
	{
		.event_table = { 0, 0 },
		.metric_table = { 0, 0 },
	},
};

static void decompress_event(int offset, struct pmu_event *pe)
{
	const char *p = &big_c_string[offset];

	pe->name = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->topic = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->desc = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->event = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->compat = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->deprecated = *p - '0';
	p++;
	pe->perpkg = *p - '0';
	p++;
	pe->unit = (*p == '\0' ? NULL : p);
	while (*p++);
	pe->long_desc = (*p == '\0' ? NULL : p);
}

static void decompress_metric(int offset, struct pmu_metric *pm)
{
	const char *p = &big_c_string[offset];

	pm->metric_name = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->metric_group = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->metric_expr = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->metric_threshold = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->desc = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->long_desc = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->unit = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->compat = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->metricgroup_no_group = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->default_metricgroup_name = (*p == '\0' ? NULL : p);
	while (*p++);
	pm->aggr_mode = *p - '0';
	p++;
	pm->event_grouping = *p - '0';
}

static int pmu_events_table__for_each_event_pmu(const struct pmu_events_table *table,
                                                const struct pmu_table_entry *pmu,
                                                pmu_event_iter_fn fn,
                                                void *data)
{
        int ret;
        struct pmu_event pe = {
                .pmu = &big_c_string[pmu->pmu_name.offset],
        };

        for (uint32_t i = 0; i < pmu->num_entries; i++) {
                decompress_event(pmu->entries[i].offset, &pe);
                if (!pe.name)
                        continue;
                ret = fn(&pe, table, data);
                if (ret)
                        return ret;
        }
        return 0;
 }

static int pmu_events_table__find_event_pmu(const struct pmu_events_table *table,
                                            const struct pmu_table_entry *pmu,
                                            const char *name,
                                            pmu_event_iter_fn fn,
                                            void *data)
{
        struct pmu_event pe = {
                .pmu = &big_c_string[pmu->pmu_name.offset],
        };
        int low = 0, high = pmu->num_entries - 1;

        while (low <= high) {
                int cmp, mid = (low + high) / 2;

                decompress_event(pmu->entries[mid].offset, &pe);

                if (!pe.name && !name)
                        goto do_call;

                if (!pe.name && name) {
                        low = mid + 1;
                        continue;
                }
                if (pe.name && !name) {
                        high = mid - 1;
                        continue;
                }

                cmp = strcasecmp(pe.name, name);
                if (cmp < 0) {
                        low = mid + 1;
                        continue;
                }
                if (cmp > 0) {
                        high = mid - 1;
                        continue;
                }
  do_call:
                return fn ? fn(&pe, table, data) : 0;
        }
        return PMU_EVENTS__NOT_FOUND;
}

int pmu_events_table__for_each_event(const struct pmu_events_table *table,
                                    struct perf_pmu *pmu,
                                    pmu_event_iter_fn fn,
                                    void *data)
{
        for (size_t i = 0; i < table->num_pmus; i++) {
                const struct pmu_table_entry *table_pmu = &table->pmus[i];
                const char *pmu_name = &big_c_string[table_pmu->pmu_name.offset];
                int ret;

                if (pmu && !pmu__name_match(pmu, pmu_name))
                        continue;

                ret = pmu_events_table__for_each_event_pmu(table, table_pmu, fn, data);
                if (ret)
                        return ret;
        }
        return 0;
}

int pmu_events_table__find_event(const struct pmu_events_table *table,
                                 struct perf_pmu *pmu,
                                 const char *name,
                                 pmu_event_iter_fn fn,
                                 void *data)
{
        for (size_t i = 0; i < table->num_pmus; i++) {
                const struct pmu_table_entry *table_pmu = &table->pmus[i];
                const char *pmu_name = &big_c_string[table_pmu->pmu_name.offset];
                int ret;

                if (!pmu__name_match(pmu, pmu_name))
                        continue;

                ret = pmu_events_table__find_event_pmu(table, table_pmu, name, fn, data);
                if (ret != PMU_EVENTS__NOT_FOUND)
                        return ret;
        }
        return PMU_EVENTS__NOT_FOUND;
}

size_t pmu_events_table__num_events(const struct pmu_events_table *table,
                                    struct perf_pmu *pmu)
{
        size_t count = 0;

        for (size_t i = 0; i < table->num_pmus; i++) {
                const struct pmu_table_entry *table_pmu = &table->pmus[i];
                const char *pmu_name = &big_c_string[table_pmu->pmu_name.offset];

                if (pmu__name_match(pmu, pmu_name))
                        count += table_pmu->num_entries;
        }
        return count;
}

static int pmu_metrics_table__for_each_metric_pmu(const struct pmu_metrics_table *table,
                                                const struct pmu_table_entry *pmu,
                                                pmu_metric_iter_fn fn,
                                                void *data)
{
        int ret;
        struct pmu_metric pm = {
                .pmu = &big_c_string[pmu->pmu_name.offset],
        };

        for (uint32_t i = 0; i < pmu->num_entries; i++) {
                decompress_metric(pmu->entries[i].offset, &pm);
                if (!pm.metric_expr)
                        continue;
                ret = fn(&pm, table, data);
                if (ret)
                        return ret;
        }
        return 0;
}

int pmu_metrics_table__for_each_metric(const struct pmu_metrics_table *table,
                                     pmu_metric_iter_fn fn,
                                     void *data)
{
        for (size_t i = 0; i < table->num_pmus; i++) {
                int ret = pmu_metrics_table__for_each_metric_pmu(table, &table->pmus[i],
                                                                 fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

static const struct pmu_events_map *map_for_cpu(struct perf_cpu cpu)
{
        static struct {
                const struct pmu_events_map *map;
                struct perf_cpu cpu;
        } last_result;
        static struct {
                const struct pmu_events_map *map;
                char *cpuid;
        } last_map_search;
        static bool has_last_result, has_last_map_search;
        const struct pmu_events_map *map = NULL;
        char *cpuid = NULL;
        size_t i;

        if (has_last_result && last_result.cpu.cpu == cpu.cpu)
                return last_result.map;

        cpuid = get_cpuid_allow_env_override(cpu);

        /*
         * On some platforms which uses cpus map, cpuid can be NULL for
         * PMUs other than CORE PMUs.
         */
        if (!cpuid)
                goto out_update_last_result;

        if (has_last_map_search && !strcmp(last_map_search.cpuid, cpuid)) {
                map = last_map_search.map;
                free(cpuid);
        } else {
                i = 0;
                for (;;) {
                        map = &pmu_events_map[i++];

                        if (!map->arch) {
                                map = NULL;
                                break;
                        }

                        if (!strcmp_cpuid_str(map->cpuid, cpuid))
                                break;
               }
               free(last_map_search.cpuid);
               last_map_search.cpuid = cpuid;
               last_map_search.map = map;
               has_last_map_search = true;
        }
out_update_last_result:
        last_result.cpu = cpu;
        last_result.map = map;
        has_last_result = true;
        return map;
}

static const struct pmu_events_map *map_for_pmu(struct perf_pmu *pmu)
{
        struct perf_cpu cpu = {-1};

        if (pmu)
                cpu = perf_cpu_map__min(pmu->cpus);
        return map_for_cpu(cpu);
}

const struct pmu_events_table *perf_pmu__find_events_table(struct perf_pmu *pmu)
{
        const struct pmu_events_map *map = map_for_pmu(pmu);

        if (!map)
                return NULL;

        if (!pmu)
                return &map->event_table;

        for (size_t i = 0; i < map->event_table.num_pmus; i++) {
                const struct pmu_table_entry *table_pmu = &map->event_table.pmus[i];
                const char *pmu_name = &big_c_string[table_pmu->pmu_name.offset];

                if (pmu__name_match(pmu, pmu_name))
                         return &map->event_table;
        }
        return NULL;
}

const struct pmu_metrics_table *pmu_metrics_table__find(void)
{
        struct perf_cpu cpu = {-1};
        const struct pmu_events_map *map = map_for_cpu(cpu);

        return map ? &map->metric_table : NULL;
}

const struct pmu_events_table *find_core_events_table(const char *arch, const char *cpuid)
{
        for (const struct pmu_events_map *tables = &pmu_events_map[0];
             tables->arch;
             tables++) {
                if (!strcmp(tables->arch, arch) && !strcmp_cpuid_str(tables->cpuid, cpuid))
                        return &tables->event_table;
        }
        return NULL;
}

const struct pmu_metrics_table *find_core_metrics_table(const char *arch, const char *cpuid)
{
        for (const struct pmu_events_map *tables = &pmu_events_map[0];
             tables->arch;
             tables++) {
                if (!strcmp(tables->arch, arch) && !strcmp_cpuid_str(tables->cpuid, cpuid))
                        return &tables->metric_table;
        }
        return NULL;
}

int pmu_for_each_core_event(pmu_event_iter_fn fn, void *data)
{
        for (const struct pmu_events_map *tables = &pmu_events_map[0];
             tables->arch;
             tables++) {
                int ret = pmu_events_table__for_each_event(&tables->event_table,
                                                           /*pmu=*/ NULL, fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

int pmu_for_each_core_metric(pmu_metric_iter_fn fn, void *data)
{
        for (const struct pmu_events_map *tables = &pmu_events_map[0];
             tables->arch;
             tables++) {
                int ret = pmu_metrics_table__for_each_metric(&tables->metric_table, fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

const struct pmu_events_table *find_sys_events_table(const char *name)
{
        for (const struct pmu_sys_events *tables = &pmu_sys_event_tables[0];
             tables->name;
             tables++) {
                if (!strcmp(tables->name, name))
                        return &tables->event_table;
        }
        return NULL;
}

int pmu_for_each_sys_event(pmu_event_iter_fn fn, void *data)
{
        for (const struct pmu_sys_events *tables = &pmu_sys_event_tables[0];
             tables->name;
             tables++) {
                int ret = pmu_events_table__for_each_event(&tables->event_table,
                                                           /*pmu=*/ NULL, fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

int pmu_for_each_sys_metric(pmu_metric_iter_fn fn, void *data)
{
        for (const struct pmu_sys_events *tables = &pmu_sys_event_tables[0];
             tables->name;
             tables++) {
                int ret = pmu_metrics_table__for_each_metric(&tables->metric_table, fn, data);

                if (ret)
                        return ret;
        }
        return 0;
}

static const int metricgroups[][2] = {

};

const char *describe_metricgroup(const char *group)
{
        int low = 0, high = (int)ARRAY_SIZE(metricgroups) - 1;

        while (low <= high) {
                int mid = (low + high) / 2;
                const char *mgroup = &big_c_string[metricgroups[mid][0]];
                int cmp = strcmp(mgroup, group);

                if (cmp == 0) {
                        return &big_c_string[metricgroups[mid][1]];
                } else if (cmp < 0) {
                        low = mid + 1;
                } else {
                        high = mid - 1;
                }
        }
        return NULL;
}
